//=========================================================
//  ToSVCD
//    transcode DVB-VDR recordings to SVCD
//
//  $Id: tosvcd.h 1.7 Fri, 06 Dec 2002 11:05:15 +0100 ws $
//
//  (C) Copyright 2002 Werner Schweer (ws@seh.de)
//=========================================================

#ifndef __TOSVCD_H__
#define __TOSVCD_H__

//---------------------------------------------------------
//   Index
//---------------------------------------------------------

// Picture types:
enum PictureType { NO_PICTURE=0, I_FRAME=1, P_FRAME=2, B_FRAME=3 };

struct Index {
      int offset;
      unsigned char type;
      unsigned char number;
      short reserved;
      };

//---------------------------------------------------------
//   AudioStream
//---------------------------------------------------------

struct AudioStream {
      bool audioHeaderFound;
      bool audioSync;
      int header;
      int bitrate;
      int samplerate;
      int segBytesLeft;
      int layer;
      int lsf;

   public:
      void init();
      bool headCheck() const;
      void putData(int len, FILE* ao);
      int decodeHeader();
      };

//---------------------------------------------------------
//   MFile
//    "multi" file abstraction
//---------------------------------------------------------

struct MFile {
      int curFile;
      int files;
      char**filenames;
      FILE* in;

   public:
      MFile()           { curFile = -1; in = 0; }
      int get();
      void close();
      bool open();
      bool eof() const  { return feof(in); }
      void rewind()     { fseek(in, 0, SEEK_SET); }
      long pos() const  { return ftell(in); }
      bool seekPic(int pic);
      };

#endif

